/*	FROMCPM.C  --	copy from CP/M to MS-DOS on the PC	*/

/*	CP/M	codes	*/

#define	OPEN_CODE	15
#define CLOSE_CODE	16
#define FIRST_CODE	17
#define NEXT_CODE	18
#define DELETE_CODE	19
#define READ_CODE	20
#define WRITE_CODE	21
#define MAKE_CODE	22
#define RENAME_CODE	23
#define SETDMA_CODE	26


#define LF		10
#define CR		13

char name[20];
int  totsize;

int  cpm_num,dirptr[200];

char cpmblock[2048];


char cpmdrive,doubled, wildcard, cpmname[11];
char buffer[512];

struct {char present,nam[8],ext[3],extent,blipb,blipc;
		char nblock; char blocks[16];} *file;

char cpmdir[64][32];



main(argc,argv)
	int  argc;
	char *argv[]; {
	char command;

	puts("CP/M to MS-DOS Copy Utility\n");

	new_cpm();

	while (1) {
		puts("\n     F   From CP/M to MS-DOS\n");
		puts(  "     L   List directory\n");
		puts(  "     Q   Quit                 ?? ");
		command=toupper(getchar());
		puts("\n\n");

		switch (command) {
			case 'F':	from_cpm();
						break;
			case 'L':	cpm_dir();
						break;
			case 'Q':	exit();
			}

		}
	}




/*	NEW_CPM  --	read cpmdrive and disk read in CPM.DIR.	*/

new_cpm() {
	char *ndir,tname[11];
	int  gap,i,j,k,temp;

need_drive:
	puts("\nCP/M drive    (A to J.   default B)   ?");
	cpmdrive=toupper(getchar());
	putchar('\n');
	if (cpmdrive == '\r') cpmdrive='B';
	if (cpmdrive < 'A' || cpmdrive > 'Z') goto need_drive;
	cpmdrive-='A';

	if (reads(cpmblock,cpmdrive,0,0,1) == -1) {
		puts("Cannot Read Drive ");
		putchar('A'+cpmdrive);
		putchar('\n');
		goto need_drive;
		}

/*	see if disk is an CP/M disk.	*/

	if (cpmblock[511] == 0) doubled=0;
	else if (cpmblock[511] == 1) doubled=1;
	else {
		puts("Not an CP/M disk\n");
		goto need_drive;
		}

	ndir=cpmdir;
	for (i=1; i <= 4; i++) {
		if (reads(ndir,cpmdrive,0,1,i) == -1) {
			puts("Cannot Read CP/M Directory\n");
			goto need_drive;
			}
		ndir+=512;
		}
/*		sort dirptr to point to directry entries in order	*/


	dirptr[0]=cpmdir;
	for (i=0; i < 64; i++) {
		if (dirptr[i].present == 0xE5) break;
		dirptr[i+1]=dirptr[i]+32;
		}
	dirptr[i+1]=0;
	cpm_num=i;
	if (!cpm_num) {
		puts("no files on CP/M disk");
		goto need_drive;
		}

	for (gap = cpm_num>>1; gap > 0; gap>>=1) {
		for (i=gap; i < cpm_num; i++) {
			for (j=i-gap; j >= 0 && over(dirptr[j],dirptr[j+gap]); j-=gap) {
				temp=dirptr[j];
				dirptr[j]=dirptr[j+gap];
				dirptr[j+gap]=temp;
				}
			}
		}
	}




/*	CPM_DIR  --	print directory of an CPM disk.	*/

cpm_dir() {
	int  num,i,used;
	long tspace,space;

	tspace=num=0;

	cpm_num=0;
	while (dirptr[cpm_num]) {
		file=dirptr[cpm_num];
		if (++num == 4) {
			putchar('\n');
			num=1;
			}
		else if (num > 1) puts("   ");
		space=0;
		do {
			space+=dirptr[cpm_num].nblock;
			cpm_num++;
			}
		while (dirptr[cpm_num] && dirptr[cpm_num].extent);
		
		oname(file->nam);
		tspace+=space;
		osize(space);
		}
	puts("\ntotal used = ");
	osize(tspace);
	putchar('\n');
	return;
	}




/*	FROM_CPM  --	copy from CPM to MS-DOS	*/

from_cpm() {
	char drive,itrack,*bufp;
	int  i,j,ileft,numfile=0,fil;
	char msname[40],*blkat;

	puts("CPM name patern ? ");
	if (pattern() == 0) return;

	if (wildcard) {
		puts("MS-DOS drive (A to Z.    default A)    ?");
		drive=toupper(getchar());
		putchar('\n');
		if (drive == '\r') drive='A';
		if (drive < 'A' || drive > 'Z') {
			puts("Illegal drive\n");
			return;
			}
		msname[0]=drive;
		msname[1]=':';
		}
	else {
		puts("MS-DOS name or drive (default A:) ? ");
		gets(msname);
		if (msname[0] == 0) {
			msname[0]='A';
			msname[1]+':';
			}
		if (msname[0] && msname[1] == ':' && msname[2] == 0) wildcard=1;
		}

	cpm_num=0;
	while (next_cpm()) {
		numfile++;
		j=2;
		file=dirptr[cpm_num];
		if (wildcard) {
			for (i=0; i < 8; i++)
				if (file.nam[i] != ' ') msname[j++]=file.nam[i] & 0x7f;
			if (file.ext[0] != ' ') {
				msname[j++]='.';
				for (i=0; i < 3; i++)
					if (file.ext[i] != ' ') msname[j++]=file.ext[i] & 0x7f;
				}
			msname[j]=0;
			}
		oname(&file.nam[0]);
		puts("  ");
		if ((fil=creat(msname)) == 0) {
			puts("cannot create ");
			puts(msname);
			return;
			}
		do {
			ileft=file.nblock;
			blkat=&file.blocks;
			while (ileft) {
				cpm_read(*blkat);
				j=doubled ? 16: 8;
				if (j > ileft) j=ileft;
				if (write(fil,cpmblock,j<<7) == -1) {
					puts("cannot write ");
					puts(msname);
					return;
					}
				ileft-=j;
				blkat++;
				}
			file=dirptr[++cpm_num];
			}
		while (file && file.extent);

		if (close(fil) == -1) {
			puts("cannot close ");
			puts(msname);
			return;
			}
		puts("copied to ");
		puts(msname);
		putchar('\n');
		}
	if (numfile == 0) puts("File not found\n");
	}






/*	NEXTCPM  --	return when find the next directry entry that matches
					the CPM filename pattern.	*/

next_cpm() {
	int  i;

	while (dirptr[cpm_num]) {
		if(dirptr[cpm_num].extent == 0) {
			file=dirptr[cpm_num];
			if (file->present == 0 && (cpmname[0] == '?' || 
				file->nam[0] == cpmname[0])) {
				i=1;
				while (cpmname[i] == '?' || file->nam[i] == cpmname[i]) i++;
				if (i > 11) return 1;
				}
			}
		cpm_num++;
		}
	return 0;
	}




/*	CPM_READ  --	given the block number, read the block. */

cpm_read(num)
	int  num; {
	int  i,blks;
	char *readinto;

	blks=2;
	num+=num;
	if (doubled) {
		blks=4;
		num+=num;
		}
	readinto=cpmblock;
	for (i=0; i < blks; i++) {
		if (readone(num,readinto) == -1) return -1;
		readinto+=512;
		}
	return 0;
	}


readone(num,into)
	int  num;
	char *into; {
	int  trk,head;

	trk=(num >> 3)+1;
	head=0;
	if (trk > 39) {
		trk=79-trk;
		head=1;
		}
	if (reads(into,cpmdrive,head,trk,(num & 7)+1) == -1) {
		puts("cannot read from drive ");
		putchar(cpmdrive+'A');
		exit();
		}
	}



/*	PATTERN  --	decode a wild card reference.	*/

pattern() {
	int  i,next;
	char cha,drive;

	wildcard=0;
	next=0;
	gets(name);

/*	copy the name, expanding * to ?	*/

	for (i=0; i < 8; i++) {
		cha=toupper(name[next]);
		if (cha == '*') cha='?';
		else if (cha == '.' || cha == 0) cha=' ';
		else next++;
		if (cha == '?') wildcard=1;
		cpmname[i]=cha;
		}

	if (name[next] == '*') next++;
	if (name[next] == '.') next++;

	for (i=8; i < 11; i++) {
		cha=toupper(name[next]);
		if (cha == '*') cha='?';
		else if (cha != 0) next++;
		else cha=' ';
		if (cha == '?') wildcard=1;
		cpmname[i]=cha;
		}

	if (name[next] == '*') next++;
	if (name[next] == 0) return 1;

bad_name:
	puts("Illegal Name = ");
	puts(name);
	putchar('\n');
	return 0;
	}




/*	ONAME  --	print a CPM name	*/

oname(str)
	char *str; {
	int  i,len;

	len=0;
	for (i=0; i < 8; i++) {
		if (*str != ' ') {
			putchar(*str & 0x7f);
			len++;
			}
		str++;
		}
	if (*str) {
		putchar('.');
		len++;
		for (i=0; i < 3; i++) {
			if (*str != ' ') {
				putchar(*str & 0x7f);
				len++;
				}
			str++;
			}
		}
	while (++len < 15) putchar(' ');
	}





/*	OSIZE  --	print a long unsigned	*/

long ldig[6]={1l,10l,100l,1000l,10000l,100000l};

osize(nblk)
	int nblk; {
	int  i;
	char signif,digit;
	long num;

	num=((long)nblk) << 7;
	signif=' ';
	i=5;
	do {
		if (i == 0) signif='0';
		digit=0;
		while (num >= ldig[i]) {
			digit++;
			num-=ldig[i];
			}
		if (digit) {
			putchar(digit+'0');
			signif='0';
			}
		else putchar(signif);
		}
	while (i--);
	}



/*	OVER  --	return true if first string is greater than second	*/

over(stra,strb)
	char *stra,*strb; {
	char max;

	max=13;
	do {
		if (*++stra > *++strb) return 1;
		}
	while (*stra == *strb && --max);
	return 0;
	}



dummy() {

#asm
;	READS.A	--	read a sector on a P/C

	cseg
	public	reads_
	

reads_:	push	bp
	mov	bp,sp
	mov	ah,2			;read command
	mov	cx,ds			;set es:bx to buffer address
	mov	es,cx
	mov	bx,[bp+4]
	mov	al,1			;number of sectors
	mov	cl,[bp+12]		;sector
	mov	ch,[bp+10]		;track
	mov	dh,[bp+8]		;head
	mov	dl,[bp+6]		;drive
	int	13h			;do the read
	pop	bp
	jc	fail
	xor	ax,ax
	ret
fail:	mov	ax,-1
	ret
#
}
